| Flutter Impeller |

Public Member Functions | List of all members
impeller::BorderMaskBlurFilterContents Class Referencefinal

`#include <border_mask_blur_filter_contents.h>`

Inheritance diagram for impeller::BorderMaskBlurFilterContents:

## Public Member Functions
| BorderMaskBlurFilterContents ()
| ~BorderMaskBlurFilterContents () override
void | SetSigma (Sigma sigma_x, Sigma sigma_y)
void | SetBlurStyle (BlurStyle blur_style)
std::optional< Rect > | GetFilterCoverage (const FilterInput::Vector &inputs, const Entity &entity, const Matrix &effect_transform) const override
| Internal utility method for |GetLocalCoverage| that computes the output coverage of this filter across the specified inputs, ignoring the coverage hint. More...
std::optional< Rect > | GetFilterSourceCoverage (const Matrix &effect_transform, const Rect &output_limit) const override
| Internal utility method for |GetSourceCoverage| that computes the inverse effect of this transform on the specified output coverage, ignoring the inputs which will be accommodated by the caller. More...
Public Member Functions inherited from impeller::FilterContents
| FilterContents ()
| ~FilterContents () override
void | SetInputs (FilterInput::Vector inputs)
| The input texture sources for this filter. Each input's emitted texture is expected to have premultiplied alpha colors. More...
void | SetEffectTransform (const Matrix &effect_transform)
| Sets the transform which gets appended to the effect of this filter. Note that this is in addition to the entity's transform. More...
std::optional< Entity > | GetEntity (const ContentContext &renderer, const Entity &entity, const std::optional< Rect > &coverage_hint) const
| Create an Entity that renders this filter's output. More...
bool | Render (const ContentContext &renderer, const Entity &entity, RenderPass &pass) const override
std::optional< Rect > | GetCoverage (const Entity &entity) const override
| Get the area of the render pass that will be affected when this contents is rendered. More...
void | PopulateGlyphAtlas (const std::shared_ptr< LazyGlyphAtlas > &lazy_glyph_atlas, Scalar scale) override
| Add any text data to the specified lazy atlas. The scale parameter must be used again later when drawing the text. More...
std::optional< Snapshot > | RenderToSnapshot (const ContentContext &renderer, const Entity &entity, std::optional< Rect > coverage_limit=std::nullopt, const std::optional< SamplerDescriptor > &sampler_descriptor=std::nullopt, bool msaa_enabled=true, const std::string &label="Filter Snapshot") const override
| Render this contents to a snapshot, respecting the entity's transform, path, clip depth, and blend mode. The result texture size is always the size of `GetCoverage(entity)`. More...
const FilterContents * | AsFilter () const override
| Cast to a filter. Returns `nullptr` if this Contents is not a filter. More...
std::optional< Rect > | GetSourceCoverage (const Matrix &effect_transform, const Rect &output_limit) const
| Determines the coverage of source pixels that will be needed to produce results for the specified |output_limit| under the specified |effect_transform|. This is essentially a reverse of the |GetCoverage| method computing a source coverage from an intended |output_limit| coverage. More...
virtual Matrix | GetLocalTransform (const Matrix &parent_transform) const
Matrix | GetTransform (const Matrix &parent_transform) const
virtual bool | IsTranslationOnly () const
| Returns true if this filter graph doesn't perform any basis transforms to the filtered content. For example: Rotating, scaling, and skewing are all basis transforms, but translating is not. More...
bool | IsLeaf () const
| Returns `true` if this filter does not have any `FilterInput` children. More...
void | SetLeafInputs (const FilterInput::Vector &inputs)
| Replaces the set of all leaf `FilterContents` with a new set of `FilterInput`s. More...
virtual void | SetRenderingMode (Entity::RenderingMode rendering_mode)
| Marks this filter chain as applying in a subpass scenario. More...
Public Member Functions inherited from impeller::Contents
| Contents ()
virtual | ~Contents ()
void | SetCoverageHint (std::optional< Rect > coverage_hint)
| Hint that specifies the coverage area of this Contents that will actually be used during rendering. This is for optimization purposes only and can not be relied on as a clip. May optionally affect the result of `GetCoverage()`. More...
const std::optional< Rect > & | GetCoverageHint () const
virtual bool | IsOpaque () const
| Whether this Contents only emits opaque source colors from the fragment stage. This value does not account for any entity properties (e.g. the blend mode), clips/visibility culling, or inherited opacity. More...
virtual ClipCoverage | GetClipCoverage (const Entity &entity, const std::optional< Rect > &current_clip_coverage) const
| Given the current pass space bounding rectangle of the clip buffer, return the expected clip coverage after this draw call. This should only be implemented for contents that may write to the clip buffer. More...
virtual bool | ShouldRender (const Entity &entity, const std::optional< Rect > clip_coverage) const
std::optional< Size > | GetColorSourceSize () const
| Return the color source's intrinsic size, if available. More...
void | SetColorSourceSize (Size size)
virtual bool | CanInheritOpacity (const Entity &entity) const
| Whether or not this contents can accept the opacity peephole optimization. More...
virtual void | SetInheritedOpacity (Scalar opacity)
| Inherit the provided opacity. More...
virtual std::optional< Color > | AsBackgroundColor (const Entity &entity, ISize target_size) const
| Returns a color if this Contents will flood the given `target_size` with a color. This output color is the "Source" color that will be used for the Entity's blend operation. More...
virtual bool | ApplyColorFilter (const ColorFilterProc &color_filter_proc)
| If possible, applies a color filter to this contents inputs on the CPU. More...

## Additional Inherited Members
Public Types inherited from impeller::FilterContents
enum | BlurStyle { BlurStyle::kNormal, BlurStyle::kSolid, BlurStyle::kOuter, BlurStyle::kInner }
enum | MorphType { MorphType::kDilate, MorphType::kErode }
Public Types inherited from impeller::Contents
using | ColorFilterProc = std::function< Color(Color)>
using | RenderProc = std::function< bool(const ContentContext &renderer, const Entity &entity, RenderPass &pass)>
using | CoverageProc = std::function< std::optional< Rect >(const Entity &entity)>
Static Public Member Functions inherited from impeller::FilterContents
static std::shared_ptr< FilterContents > | MakeDirectionalGaussianBlur (FilterInput::Ref input, Sigma sigma, Vector2 direction, BlurStyle blur_style=BlurStyle::kNormal, Entity::TileMode tile_mode=Entity::TileMode::kDecal, bool is_second_pass=false, Sigma secondary_sigma={})
static std::shared_ptr< FilterContents > | MakeGaussianBlur (const FilterInput::Ref &input, Sigma sigma_x, Sigma sigma_y, BlurStyle blur_style=BlurStyle::kNormal, Entity::TileMode tile_mode=Entity::TileMode::kDecal)
static std::shared_ptr< FilterContents > | MakeBorderMaskBlur (FilterInput::Ref input, Sigma sigma_x, Sigma sigma_y, BlurStyle blur_style=BlurStyle::kNormal)
static std::shared_ptr< FilterContents > | MakeDirectionalMorphology (FilterInput::Ref input, Radius radius, Vector2 direction, MorphType morph_type)
static std::shared_ptr< FilterContents > | MakeMorphology (FilterInput::Ref input, Radius radius_x, Radius radius_y, MorphType morph_type)
static std::shared_ptr< FilterContents > | MakeMatrixFilter (FilterInput::Ref input, const Matrix &matrix, const SamplerDescriptor &desc)
static std::shared_ptr< FilterContents > | MakeLocalMatrixFilter (FilterInput::Ref input, const Matrix &matrix)
static std::shared_ptr< FilterContents > | MakeYUVToRGBFilter (std::shared_ptr< Texture > y_texture, std::shared_ptr< Texture > uv_texture, YUVColorSpace yuv_color_space)
Static Public Member Functions inherited from impeller::Contents
static std::shared_ptr< Contents > | MakeAnonymous (RenderProc render_proc, CoverageProc coverage_proc)

## Detailed Description

Definition at line 15 of file border_mask_blur_filter_contents.h.

## Constructor & Destructor Documentation

## ◆ BorderMaskBlurFilterContents()

impeller::BorderMaskBlurFilterContents::BorderMaskBlurFilterContents | ( |  | ) |
| default

## ◆ ~BorderMaskBlurFilterContents()

impeller::BorderMaskBlurFilterContents::~BorderMaskBlurFilterContents | ( |  | ) |
| override default

## Member Function Documentation

## ◆ GetFilterCoverage()

std::optional< Rect > impeller::BorderMaskBlurFilterContents::GetFilterCoverage | ( | const FilterInput::Vector & | inputs,
|  | const Entity & | entity,
|  | const Matrix & | effect_transform
| ) |  | const
| override virtual

Internal utility method for |GetLocalCoverage| that computes the output coverage of this filter across the specified inputs, ignoring the coverage hint.

Reimplemented from impeller::FilterContents.

Definition at line 147 of file border_mask_blur_filter_contents.cc.

150 {
151 if (inputs.empty()) {
152 return std::nullopt;
153 }
154
155 auto coverage = inputs[0]->GetCoverage(entity);
156 if (!coverage.has_value()) {
157 return std::nullopt;
158 }
159 auto transform = inputs[0]->GetTransform(entity) * effect_transform;
160 auto transformed_blur_vector =
161 transform.TransformDirection(Vector2(Radius{sigma_x_}.radius, 0)).Abs() +
162 transform.TransformDirection(Vector2(0, Radius{sigma_y_}.radius)).Abs();
163 return coverage->Expand(transformed_blur_vector);
164 }

References impeller::TRect< T >::Expand(), and impeller::Matrix::TransformDirection().

## ◆ GetFilterSourceCoverage()

std::optional< Rect > impeller::BorderMaskBlurFilterContents::GetFilterSourceCoverage | ( | const Matrix & | effect_transform,
|  | const Rect & | output_limit
| ) |  | const
| override virtual

Internal utility method for |GetSourceCoverage| that computes the inverse effect of this transform on the specified output coverage, ignoring the inputs which will be accommodated by the caller.

Implements impeller::FilterContents.

Definition at line 166 of file border_mask_blur_filter_contents.cc.

168 {
169 auto transformed_blur_vector =
170 effect_transform.TransformDirection(Vector2(Radius{sigma_x_}.radius, 0))
171 .Abs() +
172 effect_transform.TransformDirection(Vector2(0, Radius{sigma_y_}.radius))
173 .Abs();
174 return output_limit.Expand(transformed_blur_vector);
175 }

References impeller::TRect< T >::Expand(), and impeller::Matrix::TransformDirection().

## ◆ SetBlurStyle()

void impeller::BorderMaskBlurFilterContents::SetBlurStyle | ( | BlurStyle | blur_style | ) |

Definition at line 24 of file border_mask_blur_filter_contents.cc.

24 {
25 blur_style_ = blur_style;
26
27 switch (blur_style) {
28 case FilterContents::BlurStyle::kNormal:
29 src_color_factor_ = false;
30 inner_blur_factor_ = true;
31 outer_blur_factor_ = true;
32 break;
33 case FilterContents::BlurStyle::kSolid:
34 src_color_factor_ = true;
35 inner_blur_factor_ = false;
36 outer_blur_factor_ = true;
37 break;
38 case FilterContents::BlurStyle::kOuter:
39 src_color_factor_ = false;
40 inner_blur_factor_ = false;
41 outer_blur_factor_ = true;
42 break;
43 case FilterContents::BlurStyle::kInner:
44 src_color_factor_ = false;
45 inner_blur_factor_ = true;
46 outer_blur_factor_ = false;
47 break;
48 }
49 }

References impeller::FilterContents::kInner, impeller::FilterContents::kNormal, impeller::FilterContents::kOuter, and impeller::FilterContents::kSolid.

## ◆ SetSigma()

void impeller::BorderMaskBlurFilterContents::SetSigma | ( | Sigma | sigma_x,
|  | Sigma | sigma_y
| ) |  |

Definition at line 19 of file border_mask_blur_filter_contents.cc.

19 {
20 sigma_x_ = sigma_x;
21 sigma_y_ = sigma_y;
22 }

The documentation for this class was generated from the following files:

- impeller/entity/contents/filters/border_mask_blur_filter_contents.h
- impeller/entity/contents/filters/border_mask_blur_filter_contents.cc

impeller::Vector2
Point Vector2
Definition: point.h:312
impeller::FilterContents::BlurStyle::kNormal
@ kNormal
Blurred inside and outside.
impeller::FilterContents::BlurStyle::kSolid
@ kSolid
Solid inside, blurred outside.
impeller::FilterContents::BlurStyle::kInner
@ kInner
Blurred inside, nothing outside.
impeller::FilterContents::BlurStyle::kOuter
@ kOuter
Nothing inside, blurred outside.